#!/bin/bash

# Copyright (C) 2013, 2014 Giovanni Ubaldi
#
# Author: Giovanni Ubaldi.
# http://www.ubaweb.it/miniguide/img_cerca_e_guarda.php
#   
# This file is part of cerca_foto.sh.
#
# cerca_foto.sh is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# cerca_foto.sh is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with cerca_foto.sh.  If not, see <http://www.gnu.org/licenses/>.
################################################################################

# script del 31 dicembre 2013
# aggiornata il 05 febbraio 2014
# Di Giovanni Ubaldi
# Documentazione e download: http://www.ubaweb.it/miniguide/img_cerca_e_guarda.php
# dove si può trovare anche la versione "cerca_foto_zy.sh" che fa uso di zenity

### impostazioni predefinite (rimpiazzabili interattivamente) ###
path_pre="$HOME/Immagini/"
nome_pre=''
ext_pre='jpg,gif,png,jpeg'
kb_min_pre='20 KB'
kb_max_pre='600 KB'
width_pre='140'


### impostazioni predefinite modificabili solo "a mano" ###
no_ext='vuota' # la stringa da inserire per estensione vuota, significa qualsiasi estensione o nessuna estensione
browser_pre='google-chrome'	# browser predefinito
escluse="*/\.|$HOME/www/|$HOME/xxx/" # es.2 esclude tutte le directory nascoste, 'www' e 'xxx' nella home utente. NON PUÒ ESSERE VUOTA!
solo_nel_file=1	# "1": Corrispondenza solo nel nome del file; "0": anche nel path
path_salvataggio="$HOME/risultati_cerca_foto"
salva_ricerca=0 # "1": Salva la pagina html nel path_salvataggio; "0" non salva!

########## fine impostazioni ##########
#######################################

help='Questo aiuto è visualizzabile inserendo "h" o "help" come argomento dello script preceduti, o anche no, da "-" (es: "./cerca_foto.sh h" , "./cerca_foto.sh -help").

VERSIONI: è possibile scaricare da http://www.ubaweb.it/miniguide/img_cerca_e_guarda.php la versione cerca_foto.sh che non fa uso di Zenity e cerca_foto_zy.sh che invece utilizza Zenity; le versioni: cerca_foto_xcf.sh e cerca_foto_xcf_zy.sh creano le miniature quindi non creano problemi di eccessivi rallentamenti nei browser, però richiedono che si installato xcftools (per poter gestire file .xcf).

PROGRAMMI RICHIESTI: oltre ad un browser (predefinito Chrome) e bash, devono essere installati anche ImageMagick, (Zenity per la versione _zy e anche xcftools per le versioni _xcf [ per Ubuntu: "sudo apt-get install imagemagick xcftools"])!

COSA FA
Questo script consente di cercare, in base a vari criteri di ricerca, immagini di qualsiasi tipo e di mostrarne le anteprime (nelle dimensioni volute) in una pagina del browser, con link ai file: apribili in altre schede del browser o scaricabili.
Oltre ad anteprima e nome dei file, vengono mostrate anche le dimensioni in pixel delle immagini e il "peso" dei file; il path completo è visibile (in un tooltip) fermando il puntatore sulla foto o sul link.
Le pagine dei risultati, volendo, possono essere salvate automaticamente.
Tutte le ricerche sono case insensitive. 

POSSIBILI CRITERI DI RICERCA

PREDEFINITI INTERATTIVI:
Directory (path_pre): si può inserire la directory da cui iniziare la ricerca (ricorsiva nelle sottodirectory).
Utilizzare sempre il percorso assoluto!

Nome (nome_pre): si può inserire il nome o parte del nome del file o anche niente, in questo caso verranno cercate tutti i file che rispettano gli altri criteri di ricerca inseriti.

Estensioni (ext_pre): si possono indicare: una estensione (es: jpg),
più estensioni separate da virgola "," (es: jpg,png,gif)
nessuna estensione, inserendo "vuota" (senza virgolette), in questo caso verrà  presa in esame qualsiasi estensione di immagine e/o file di immagini senza estensione.

Dimensione minima del file (kb_min_pre): si può inserire la dimensione minima del file da cercare in byte, volendo, senza indicare alcuna unità  di misura.
Per inserire dimensioni in KB, MB e GB il numero DEVE essere seguito rispettivamente da: k o kb o kilo, m o mb o mega, g o gb o giga; con gli spazi o senza, con caratteri maiuscoli o maiuscoli.
Impostare a "0": se non si desidera un limite inferiore.

Dimensione massima del file (kb_max_pre): si può inserire la dimensione massima del file da cercare, valgono le stesse regole dette per le dimensioni minime.

Dimensioni delle miniature visualizzate (width_pre): specificare la larghezza in pixel (es: 100)

Se ad ogni richiesta di inserimento si preme il tasto "Invio", senza inserire altro, verrà  utilizzata la corrispondente impostazione predefinita.

OPZIONI MODIFICABILI "A MANO"
no_ext: la stringa da inserire per non considerare estensioni; vuota indica qualsiasi estensione o nessuna estensione.

browser: Il browser in cui verrà  aperta la pagina HTML con i risultati. 
Purtroppo, da prove fatte, il browser più lento e che può dare più problemi (anche di crash) è il mio browser preferito, (per un classico utilizzo), Firefox. Consiglierei di impostare uno di questi browser: epiphany, google-cromium, google-chrome, opera. 
QUESTO PROBLEMA È STATO SUPERATO CON LE VERSIONI "_xcf" DELLO SCRIPT.
Ho messo Chrome predefinito perché è il più utilizzato.

escluse: vanno inserite le regex che identificano le directory che non saranno incluse nei risultati; (le regex devono essere separate da "|"), vedere gli esempi.

solo_nel_file: impostato a "1" mostra le corrispondenze di quanto inserito in "nome" solo se presente nel nome del file. Impostato a "0": mostra le corrispondenze di "nome" anche se trovato nel path.

path_salvataggio: path in cui salvare la pagina HTML con i risultati della ricerca.

salva_ricerca: impostato a "1": Salva la pagina html nel path_salvataggio; se impostato a "0" non salva niente, verrà  visualizzato il file HTML temporaneo! 
PER LE VERSIONI _xcf: CONSIGLIO DI LASCIARE IMPOSTATO A "0" (A MENO CHE NON SI IMPOSTI LA DIRECTORY DI SALVATAGGIO "path_conv" nella propria home).
Visto che alcune immagini vengono convertite e salvate in "/temp" si dovrebbero salvare tutte le immagini create, furi da /temp, azione che non ho implementato perché il volume di immagini salvate potrebbe essere grande ed occupare alla lunga troppo spazio disco.

(impostazioni per le versioni xcf soltanto)
path_conv:# directory di salvataggio delle miniature e della immagini convertite, di default "/tmp/img/"

(impostazioni per le versioni zy soltanto)
scelta_dir: impostata a "testo" mostra una finestra di inserimento di tipo testuale dove scrivere la directory di ricerca, con già  impostata la directory di ricerca predefinita;
se non impostata a "testo" verrà  mostrata una finestra grafica con le directory in ordine gerarchico, da selezionare; se si vuole utilizzare questa modalità, conviene impostare la variabile a "albero" (più descrittiva di una variabile vuota)

LE IMPOSTAZIONI PREDEFINITE POSSONO ESSERE VISTE E MODIFICATE NELLE PRIME RIGHE DELLO SCRIPT:

HTML E CSS
HTML e CSS della pagina creata sono minimali, servono solo per dare un esempio di come utilizzarli e di come inserirli nel codice.

CONSIGLI
Lo script è consigliato per la ricerca di un numero non troppo elevato di file e sopratutto di file non troppo grandi, i browser non sono fatti per mostrare migliaia di immagini ed hanno problemi a ridimensionare immagini molto grandi; di conseguenza si potrebbero avere rallentamenti fino anche al blocco del browser. (in caso di blocco un "killall nome_del_browser" risolve il problema). QUESTO PROBLEMA È STATO SUPERATO CON LE VERSIONI "_xcf" DELLO SCRIPT.
Per quanto sia possibile far cercare contemporaneamente qualsiasi immagine sul disco è sempre consigliabile filtrare la ricerca, almeno per dimensioni massime delle immagini e per directory.

Tips: Se si stanno cercando file con risoluzioni molto alte, impostare le dimensioni delle miniature a 0 e cercare di individuare le immagini cercate in base ai dati mostrati.
Rinunciando alle anteprime, il browser non deve caricare le immagini, ed è molto più veloce a mostrare la pagina.

PROBLEMI NOTI
Raramente, può capitare che "Identify" non riesca a leggere i dati di alcuni file. In questi casi, ogni errore viene segnalato nel terminale, la ricerca prosegue ugualmente; naturalmente le dimensioni in pixel dei file non letti correttamente non compariranno nella pagina html dei risultati.'

if [ "$1" = "h" -o "$1" = "help" -o "$1" = "-h" -o "$1" = "-help" ] ;then echo "$help" | less; exit; fi

# controllo programmi
if ! type -p "$browser_pre" > /dev/null
	then
		echo -e "Attenzione! $browser_pre non risulta installato!\nCambiare il browser nelle impostazioni predefinite oppure installarlo."
		exit 1
	else
		browser=$(type -p "$browser_pre")
fi

if ! type -p "identify" > /dev/null
	then
		echo -e 'Attenzione! "identify" non risulta installato!\nÈ necessario per mostrare i dati delle immagini.
		Installare ImageMagick'
		exit 2
	else
		id=$(type -p "identify")
fi

clear
# funzioni
verifica_min_max() {
if [ $filesize -ge $kb_min -a $filesize -le $kb_max ];then
		return 0
	else
		return 1
fi
}
kmg2byte() {
local input filesize_h um um_in byte
input="$1"
filesize_h=$(echo $input | grep -o '[0-9]*\.*[0-9]*')
um_tot=$(echo "$input" | grep -o '[a-Z]*')
um=${um_tot:0:1}

if [ "$um" = 'b' -o "$um" = 'B' -o "$um" = '' ] ;then
		byte="$filesize_h"
	else
		if $(echo "$um" | grep -iq 'k');then 
				byte=$( echo "$filesize_h * 1024" | bc )
			elif $(echo "$um" | grep -iq 'm');then
				byte=$( echo "$filesize_h * 1024 * 1024" | bc )
			elif $(echo "$um" | grep -iq 'g');then
				byte=$( echo "$filesize_h * 1024 * 1024 * 1024" | bc )
			else
				# Unità di misura non riconosciuta
				exit 1
		fi
fi
echo "scale=0; $byte / 1" | bc
}
byte2kmg() {
local filesize_B KB KBint MB MBint GB GBint
filesize_B=$1
KB=$( echo "scale=2; $filesize_B / 1024" | bc )
KBint=$( echo "$filesize_B / 1024" | bc )
MB=$( echo "scale=2; $KB / 1024" | bc )
MBint=$( echo "$KB / 1024" | bc )
GB=$( echo "scale=2; $MB / 1024" | bc )
GBint=$( echo "$MB / 1024" | bc )

if [ "$KBint" -lt 1 ] ; then
		echo "$filesize_B B"
	elif [ "$MBint" -lt 1 ] ; then
		echo "${KB}KB"
	elif [ "$GBint" -lt 1 ] ; then
		echo "${MB}M"
	else
		echo "${GB}GB"
fi
}
# inizio interazione
echo -e "Per leggere l'aiuto avviare il programma con l'argomento \"h\" o \"help\"\n es: cerca_foto.sh help\n
Sarà richiesto l'inserimento dei dati per la ricerca (tutti case insensitive). 
Ad ogni richiesta, premendo solo 'Invio' verranno usate le impostazioni\npredefinite\n"
sleep 1

# inserimento dati 
echo "Inserisci il percorso assoluto in cui cercare e/o premi 'Invio' 
predefinita: $path_pre"
read path
if [ -z "$path" ] ;then path="$path_pre";fi
if [ ! -d "$path" ] ;then echo "$path non è una directory valida!";exit 3;fi

echo "Inserisci il nome o parte del nome del file da cercare e/o premi 'Invio'
predefinito: $nome_pre"
read nome
if [ -z "$nome" ] ;then nome="$nome_pre";fi

echo "Inserisci l'estensione del file e/o premi 'Invio'.
Una sola estensione: inserirla senza il punto (es: gif)
Più estensioni: inserirle separandole con una virgola (es: jpg,svg) 
Qualsiasi o nessuna estensione, scrivere '$no_ext' e dare 'Invio'

Predefinita: $ext_pre (case insensitive)"
read ext
if [ -z "$ext" ] ;then 
		ext="$ext_pre"
		ext_msg="$ext"
	elif [ "$ext" = "$no_ext" ];then
		ext_msg="$ext"
		ext=''
	else
		ext_msg=$ext
fi
ext_rgx=$(echo "$ext" | sed 's/,/\\|/g' 2>/dev/null)

echo "Inserisci la dimensione minima del file in KB e/o premi 'Invio' 
predefinita: $kb_min_pre"
read kb_min
if [ -z "$kb_min" ] ;then kb_min="$kb_min_pre";fi
kb_min_msg="$kb_min"
kb_min=$(kmg2byte "$kb_min") || err_um="Spiacente! Unità di misura non riconosciuta! Chiudo!"
if [ "$err_um" ]; then 
	echo "$err_um"
	exit 1
fi

echo "Inserisci la dimensione massima del file in KB e/o premi 'Invio' 
predefinita: $kb_max_pre"
read kb_max
if [ -z "$kb_max" ] ;then kb_max="$kb_max_pre";fi
kb_max_msg="$kb_max"
kb_max=$(kmg2byte "$kb_max")
if [ "$kb_min" -gt "$kb_max" ] ;then
	echo -e "Il valore minimo deve essere minore o uguale del valore massimo!\nEsco"
	exit 1
fi

echo "Inserisci la larghezza in pixel delle miniature visualizzate e/o premi 'Invio' 
predefinita: $width_pre"
read width
width=$(echo "$width" | grep -o '[0-9]*')
if [ -z "$width" ] ;then width="$width_pre";fi

clear

echo "Le attuali impostazioni sono: 
nome del file: $nome
estensione: $ext_msg 
directory di partenza:$path
dimensioni del file tra $kb_min_msg e $kb_max_msg
dimensioni delle miniature $width pixel"

echo -e "\nVanno bene? \nPremere 'Invio' per eseguire la ricerca, 'R' riparte 'Q' Esci\n"

read -n1 scelta
if [ "$scelta" = "r" -o "$scelta" = "R" ] ;then 
		$0
	elif [ "$scelta" = "q" -o "$scelta" = "Q" ] ;then
		echo "esco"
		exit 4
	else
		echo -e "\n\tAttendere, ricerca in corso\n\nIn caso di ricerca eccessivamente lunga, la si può interrompere premendo la combinazione di tasti \"Ctrl+C\";\nNaturalmente interrompendo il programma i risultati della ricerca non verranno mostrati"
fi

pagina_tmp=$(tempfile) || exit 5	# path pagina temporanea

pagina_sup="<!DOCTYPE HTML>
<html>
<head>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">
<title>Risultati della ricerca </title>
<style type=\"text/css\">
#contenuto{padding:2px; border:1px solid #ccc;}
.foto_box{padding:4px; background-color: #ccf;border:1px dotted #cfc;}
</style>
</head>
<body>
<h2>Risultati della ricerca: </h2>
<h3>nome: <em>&quot;$nome&quot;</em> - ext:  <em>&quot;$ext_msg&quot;</em> min: <em>$kb_min_msg </em>, max: <em>$kb_max_msg </em> in <em>&quot;$path&quot;</em></h3>
<p>Queste sono le immagini trovate.</p>
<div id=\"contenuto\">
"
pagina_inf='</div>
</body>
</html>'

echo "$pagina_sup"  > $pagina_tmp

### RICERCA ###

locate -ir "^$path.*$nome.*\.*\(${ext_rgx}\)$" | grep -Ev "($escluse)" | while read f
do
	solo_file=$(basename "$f")
	if [ $solo_nel_file = 1 ];then
			if $(echo "$solo_file" | grep -iq "$nome") ; then
					check_file=1
				else
					check_file=0
			fi
		else
			check_file=1
	fi

	if  $(file "$f" | grep -iqw 'image') && [ $check_file = 1 ]
	then
		filesize=$(stat -c %s "$f")
		filesize_h=$(byte2kmg "$filesize")
		if $(verifica_min_max ); then
					dim=$(identify -format "%wx%h " "$f")
					dati_scelti="File: <strong>$filesize_h</strong>, Dim: <strong>${dim}px</strong>"
					echo -e "\t<div class=\"foto_box\"><a href=\"file://$f\" title=\"$f\" target=\"_blank\"><img src=\"file://$f\" width=\"$width\" title=\"$f\" alt=\"$f\" \> ^ $solo_file</a> $dati_scelti\n\t</div>\n" >>  $pagina_tmp
		fi
	fi
done

echo "$pagina_inf"  >> $pagina_tmp

echo -e "\n\tRicerca terminata!\nSarà aperto $browser_pre per mostrare i risultati"

if [ $salva_ricerca = 1 ]; then
		nome_pag="$(date +%Y-%b-%d_%H:%M:%S_${nome}.htm)"
		mkdir "$path_salvataggio" 2>/dev/null
		mv "$pagina_tmp" "$path_salvataggio/$nome_pag"
		echo -e "Risultati salvati in:\n $path_salvataggio/$nome_pag"
		"$browser" "$path_salvataggio/$nome_pag" &>/dev/null &
	else
		"$browser" "$pagina_tmp" &>/dev/null &
fi

exit 0

